import { RequestHandler } from "express";
import { getAccountIdForRequest } from "@/src/services/loginService";
import { getInventory } from "@/src/services/inventoryService";
import { getJSONfromString } from "@/src/helpers/stringHelpers";
import { WeaponTypeInternal } from "@/src/services/itemDataService";

export const setWeaponSkillTreeController: RequestHandler = async (req, res) => {
    const accountId = await getAccountIdForRequest(req);
    const inventory = await getInventory(accountId);
    const payload = getJSONfromString<ISetWeaponSkillTreeRequest>(String(req.body));

    const item = inventory[req.query.Category as WeaponTypeInternal].id(req.query.ItemId as string)!;
    item.SkillTree = payload.SkillTree;

    await inventory.save();
    res.end();
};

interface ISetWeaponSkillTreeRequest {
    SkillTree: string;
}
